/********************************************************************
    Project :   PE5004 Evaboard
    Version :   v2.0             
    Software:   PSoC Designer 
    Hardware:   PSoC MiniProg, PE5004 Evaboard
	Device	: 	CY7C64356
    Date    :   Jan 29 2009
    Author  :   HoJ
    Company :   PE Gmbh               

	desgription: menue subfunctions --> Multitouch demo, Slider demo and OLED demo
				 source code
	
******************************************************************************/

void multi_touch_demo(void)
{
	DISPLAY_CLEAR(); 
	CLEAR_RAM();  //clear display MC RAM
	DRAW_GRID_RAM(); //write display grid into RAM
	//subprogramm main while
	while(1){
		LOAD_Matrix();	//load init values for board sensor matrix array 
		LOAD_CONFIG_5004();	//send the init values to PE5004
		LOAD_CONFIG_5004();	//
		
		//sample 6 times matrix sensor and one time oleds for exit
		for (run_matrix=0;run_matrix<6;run_matrix++){
			DISP_SEND_FRAME(); //send MC display ram content to display
			RUN_MATRIX(); //start PE5004 complete sample run 
			pFILT=&SAR_FILT[0]; //set array start adress
			DRAW_GRID_RAM(); //write display grid into RAM
			
			//reset rsum array
			rsum[0]=0;
			rsum[1]=0;
			rsum[2]=0;
			rsum[3]=0;
			rsum[4]=0;
			rsum[5]=0;
			rsum[6]=0;
			rsum[7]=0;
			
			//add all values in a Row
			for (runc=1;runc<8;runc++){
				for (runr=8;runr>0;runr--){
						if (runr==1){
							rsum[0]=rsum[0]+*pFILT;
							}
						if (runr==2){
							rsum[1]=rsum[1]+*pFILT;
							}
						if (runr==3){
							rsum[2]=rsum[2]+*pFILT;
							}
						if (runr==4){
							rsum[3]=rsum[3]+*pFILT;
							}
						if (runr==5){
							rsum[4]=rsum[4]+*pFILT;
							}
						if (runr==6){
							rsum[5]=rsum[5]+*pFILT;
							}	
						if (runr==7){
							rsum[6]=rsum[6]+*pFILT;
							}
						if (runr==8){
							rsum[7]=rsum[7]+*pFILT;
							}
						pFILT++; //increment pointer
					}
				}
				
			pFILT=&SAR_FILT[0]; //set array start adress
			
			//find touch events in pFilt array that are larger than row everage 
			for (runc=1;runc<8;runc++){
				for (runr=8;runr>0;runr--){
					if (*pFILT > ((rsum[runr-1]>>3))){
						if (runc==1){
							//switch on display field
							disp_ram_page1[runr*8+34]=0xBD; 
							disp_ram_page1[runr*8+35]=0xBD; 
							disp_ram_page1[runr*8+36]=0xBD;
							disp_ram_page1[runr*8+37]=0xBD;
							}
						if (runc==2){
							//switch on display field
							disp_ram_page2[runr*8+34]=0xBD;
							disp_ram_page2[runr*8+35]=0xBD;
							disp_ram_page2[runr*8+36]=0xBD;
							disp_ram_page2[runr*8+37]=0xBD;
							}
						if (runc==3){
							//switch on display field
							disp_ram_page3[runr*8+34]=0xBD;
							disp_ram_page3[runr*8+35]=0xBD;
							disp_ram_page3[runr*8+36]=0xBD;
							disp_ram_page3[runr*8+37]=0xBD;
							}
						if (runc==4){
							//switch on display field
							disp_ram_page4[runr*8+34]=0xBD;
							disp_ram_page4[runr*8+35]=0xBD;
							disp_ram_page4[runr*8+36]=0xBD;
							disp_ram_page4[runr*8+37]=0xBD;
							}
						if (runc==5){
							//switch on display field
							disp_ram_page5[runr*8+34]=0xBD;
							disp_ram_page5[runr*8+35]=0xBD;
							disp_ram_page5[runr*8+36]=0xBD;
							disp_ram_page5[runr*8+37]=0xBD;
							}
						if (runc==6){
							//switch on display field
							disp_ram_page6[runr*8+34]=0xBD;
							disp_ram_page6[runr*8+35]=0xBD;
							disp_ram_page6[runr*8+36]=0xBD;
							disp_ram_page6[runr*8+37]=0xBD;
							}	
						if (runc==7){
							//switch on display field
							disp_ram_page7[runr*8+34]=0xBD;
							disp_ram_page7[runr*8+35]=0xBD;
							disp_ram_page7[runr*8+36]=0xBD;
							disp_ram_page7[runr*8+37]=0xBD;
							}
						}
					pFILT++; //increment pointer
					}
				}
			} // end : "for (run_matrix=0;run_matrix<6;run_matrix++)"
		
		//display return markings
		GRAPH_DRAW_STRING_RAM(4, 56, "Return");
		GRAPH_DRAW_STRING_RAM(4, 4, "<-");
		GRAPH_DRAW_STRING_RAM(4, 14, "<-");
		GRAPH_DRAW_STRING_RAM(4, 24, "<-");
		GRAPH_DRAW_STRING_RAM(4, 34, "<-");
		GRAPH_DRAW_STRING_RAM(4, 44, "<-");
		
		//init PE5004 for OLED EXIT 
		//enter_var=0; //reset enter_var
		exit_var=0;  //reset exit_var
		//LOAD_EXIT();	//load init values for board sensor oleds
		//LOAD_CONFIG_5004_OLED_EXIT(); //send the init values to PE5004
		//LOAD_CONFIG_5004_OLED_EXIT();
		LOAD_OLED_EXIT();
		LOAD_CONFIG_5004();
		RUN_OLED_EXIT(); //start PE5004 oled sample run
		
		//check if touching left oled
		if ((exit_var ==1)&&(menue_var==0)){
		//	exit_var = 0; //reset menue_var (sensor_processing set this var)
			enter_var = 0; //reset enter_var (sensor_processing set this var)
			return; //leave sub-program
		}	
		menue_var=0; //reset menue_var
	}
}

void slider_demo(void)
{
	//define local variables
	BYTE rel_temp;
	WORD rel_old_c1;
	WORD rel_old_c2;
	WORD rel_old_c3;
	WORD rel_old_c4;
	WORD rel_old_c5;
	WORD rel_old_c6;
	WORD rel_old_c7;
	WORD rel_old_c8;
	WORD summe1;
	WORD summe2;
	WORD summe3;
	WORD summe4;
	WORD summe5;
	WORD summe6;
	WORD summe7;
	WORD summe8;
	BYTE abs_c1=159;
	BYTE abs_c2=159;
	BYTE abs_c3=159;
	BYTE abs_c4=159;
	BYTE abs_c5=159;
	BYTE abs_c6=159;
	BYTE abs_c7=159;
	BYTE abs_c8=159;
	BYTE new_touch1=1;
	BYTE new_touch2=1;
	BYTE new_touch3=1;
	BYTE new_touch4=1;
	BYTE new_touch5=1;
	BYTE new_touch6=1;
	BYTE new_touch7=1;
	BYTE new_touch8=1;
	BYTE touch_delay1;
	BYTE touch_delay2;
	BYTE touch_delay3;
	BYTE touch_delay4;
	BYTE touch_delay5;
	BYTE touch_delay6;
	BYTE touch_delay7;
	BYTE touch_delay8;
	WORD rel_c1;
	WORD rel_c2; 	
	WORD rel_c3;	
	WORD rel_c4;	
	WORD rel_c5;	
	WORD rel_c6;	
	WORD rel_c7;	
	WORD rel_c8;	
	WORD pre_c1;
	WORD pre_c2;
	WORD pre_c3;
	WORD pre_c4;
	WORD pre_c5;
	WORD pre_c6;
	WORD pre_c7;
	WORD pre_c8;

	//reset variables
	exit_var = 0;
	touch_delay1 = 0;
	
	LOAD_Matrix();	//load init values for board sensor matrix array 
	LOAD_CONFIG_5004();	//send the init values to PE5004
	LOAD_CONFIG_5004();	
	RUN_MATRIX(); //5 matrix read to fill pfilt array with start values
	RUN_MATRIX();
	RUN_MATRIX();
	RUN_MATRIX();
	RUN_MATRIX();
	
	//subprogramm main while
	while(1){
	
		//sample 6 times matrix sensor and one time oleds for exit
		for (run_matrix=0;run_matrix<10;run_matrix++){
		
			LOAD_Matrix();	//load init values for board sensor matrix array 
			LOAD_CONFIG_5004();	//send the init values to PE5004
			LOAD_CONFIG_5004();
			
			//reset variables
			pre_c1=0;
			pre_c2=0;
			pre_c3=0;
			pre_c4=0;
			pre_c5=0;
			pre_c6=0;
			pre_c7=0;
			pre_c8=0;
			summe1=0;
			summe2=0;
			summe3=0;
			summe4=0;	
			summe5=0;
			summe6=0;	
			summe7=0;
			summe8=0;	
			
			CLEAR_RAM();
			DRAW_SLIDER_GRID_RAM();
			//display sliders
			DISPLAY_GRAPH_SLIDER(111, (abs_c8-97));	
			DISPLAY_GRAPH_SLIDER(101, (abs_c7-97));	
			DISPLAY_GRAPH_SLIDER(91, (abs_c6-97));	
			DISPLAY_GRAPH_SLIDER(81, (abs_c5-97));	
			DISPLAY_GRAPH_SLIDER(71, (abs_c4-97));	
			DISPLAY_GRAPH_SLIDER(61, (abs_c3-97));	
			DISPLAY_GRAPH_SLIDER(51, (abs_c2-97));	
			DISPLAY_GRAPH_SLIDER(41, (abs_c1-97));	
			GRAPH_DRAW_STRING_RAM(4, 56, "Return");
			GRAPH_DRAW_STRING_RAM(4, 4, "<-");
			GRAPH_DRAW_STRING_RAM(4, 14, "<-");
			GRAPH_DRAW_STRING_RAM(4, 24, "<-");
			GRAPH_DRAW_STRING_RAM(4, 34, "<-");
			GRAPH_DRAW_STRING_RAM(4, 44, "<-");
			DISP_SEND_FRAME();
		
			RUN_MATRIX(); //read matrix 2x
			RUN_MATRIX();	
			
			pFILT=&SAR_FILT[0]; //set array start adress
		
			//pre calculating row "balance point" first step
			for (runc=1;runc<8;runc++){
				for (runr=1;runr<9;runr++){
					if (*pFILT > 0) //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
					{
						if (runr == 1){
							pre_c8 += runc**pFILT;
							summe8 += *pFILT;
						}
						if (runr == 2){
							pre_c7 += runc**pFILT;
							summe7 += *pFILT;
						}
						if (runr == 3){
							pre_c6 += runc**pFILT;
							summe6 += *pFILT;
						}
						if (runr == 4){
							pre_c5 += runc**pFILT;
							summe5 += *pFILT;
						}
						if (runr == 5){
							pre_c4 += runc**pFILT;
							summe4 += *pFILT;
						}
						if (runr == 6){
							pre_c3 += runc**pFILT;
							summe3 += *pFILT;
						}
						if (runr == 7){
							pre_c2 += runc**pFILT;
							summe2 += *pFILT;
						}
						if (runr == 8){
							pre_c1 += runc**pFILT;
							summe1 += *pFILT;
						}	
					}
					pFILT++;			
				}		
			}
			
			//pre calculating row "balance point" final step
			rel_c1 = (pre_c1/summe1);
			rel_c2 = (pre_c2/summe2);
			rel_c3 = (pre_c3/summe3);
			rel_c4 = (pre_c4/summe4);
			rel_c5 = (pre_c5/summe5);
			rel_c6 = (pre_c6/summe6);
			rel_c7 = (pre_c7/summe7);
			rel_c8 = (pre_c8/summe8);
					
			//calculate slider 1
			if (pre_c1 > 0){
				touch_delay1 = 0;
				if (new_touch1 == 1){ //if new touch reset rel_old
					rel_old_c1 = rel_c1;
					new_touch1 = 0;
					}
				if (rel_old_c1 > rel_c1){  //if new value lesser than rel_old move slider down
					rel_temp = rel_old_c1 - rel_c1;
					if (rel_temp > 0){
						abs_c1 = abs_c1 - rel_temp;
						}
					}
				if (rel_old_c1 < rel_c1){ //if new value larger than rel_old move slider up
					rel_temp = rel_c1-rel_old_c1;
					if (rel_temp > 0){
						abs_c1 = abs_c1 + rel_temp;
						}
					}		
				if (abs_c1 > 159){ //stop leaving the display field
					abs_c1 =159;
					touch_delay1 = 0;
					new_touch1 = 1;
					}
				if (abs_c1 < 105){ //stop leaving the display field
					abs_c1 =105;
					touch_delay1 = 0;
					new_touch1 = 1;
					}
			}
			else 
			{
				if(touch_delay1 == 3){ 	//find new touch (delay)   
					touch_delay1 = 0;
					new_touch1 = 1;
					}
				touch_delay1++;	
			}
			//calculate slider 2
			if (pre_c2 > 0){
				touch_delay2 = 0;
				if (new_touch2 == 1){
					rel_old_c2 = rel_c2;
					new_touch2 = 0;
					}
				if (rel_old_c2 > rel_c2){
					rel_temp = rel_old_c2 - rel_c2;
					if (rel_temp > 0){
						abs_c2 = abs_c2 - rel_temp;
						}
					}
				if (rel_old_c2 < rel_c2){
					rel_temp = rel_c2-rel_old_c2;
					if (rel_temp > 0){
						abs_c2 = abs_c2 + rel_temp;
						}
					}		
				if (abs_c2 > 159){
					abs_c2 =159;
					touch_delay2 = 0;
					new_touch2 = 1;
					}
				if (abs_c2 < 105){
					abs_c2 =105;
					touch_delay2 = 0;
					new_touch2 = 1;
					}	
			}
			else 
			{
				if(touch_delay2 == 3){ 			//delay        
					touch_delay2 = 0;
					new_touch2 = 1;
					}
				touch_delay2++;	
			}
			//calculate slider 3
			if (pre_c3 > 0){
				touch_delay3 = 0;
				if (new_touch3 == 1){
					rel_old_c3 = rel_c3;
					new_touch3 = 0;
					}
				if (rel_old_c3 > rel_c3){
					rel_temp = rel_old_c3 - rel_c3;
					if (rel_temp > 0){
						abs_c3 = abs_c3 - rel_temp;
						}
					}
				if (rel_old_c3 < rel_c3){
					rel_temp = rel_c3-rel_old_c3;
					if (rel_temp > 0){
						abs_c3 = abs_c3 + rel_temp;
						}
					}		
				if (abs_c3 > 159){
					abs_c3 =159;
					touch_delay3 = 0;
					new_touch3 = 1;
					}
				if (abs_c3 < 105){
					abs_c3 =105;
					touch_delay3 = 0;
					new_touch3 = 1;
					}
			}
			else 
			{
				if(touch_delay3 == 3){ 			//delay        
					touch_delay3 = 0;
					new_touch3 = 1;
					}
				touch_delay3++;	
			}
			//calculate slider 4
			if (pre_c4 > 0){
				touch_delay4 = 0;
				if (new_touch4 == 1){
					rel_old_c4 = rel_c4;
					new_touch4 = 0;
					}
				if (rel_old_c4 > rel_c4){
					rel_temp = rel_old_c4 - rel_c4;
					if (rel_temp > 0){
						abs_c4 = abs_c4 - rel_temp;
						}
					}
				if (rel_old_c4 < rel_c4){
					rel_temp = rel_c4-rel_old_c4;
					if (rel_temp > 0){
						abs_c4 = abs_c4 + rel_temp;
						}
					}		
				if (abs_c4 > 159){
					abs_c4 =159;
					touch_delay4 = 0;
					new_touch4 = 1;
					}
				if (abs_c4 < 105){
					abs_c4 =105;
					touch_delay4 = 0;
					new_touch4 = 1;
					}	
			}
			else 
			{
				if(touch_delay4 == 3){ 			//delay        
					touch_delay4 = 0;
					new_touch4 = 1;
					}
				touch_delay4++;	
			}
			//calculate slider 5
			if (pre_c5 > 0){
				touch_delay5 = 0;
				if (new_touch5 == 1){
					rel_old_c5 = rel_c5;
					new_touch5 = 0;
					}
				if (rel_old_c5 > rel_c5){
					rel_temp = rel_old_c5 - rel_c5;
					if (rel_temp > 0){
						abs_c5 = abs_c5 - rel_temp;
						}
					}
				if (rel_old_c5 < rel_c5){
					rel_temp = rel_c5-rel_old_c5;
					if (rel_temp > 0){
						abs_c5 = abs_c5 + rel_temp;
						}
					}		
				if (abs_c5 > 159){
					abs_c5 =159;
					touch_delay5 = 0;
					new_touch5 = 1;
					}
				if (abs_c5 < 105){
					abs_c5 =105;
					touch_delay5 = 0;
					new_touch5 = 1;
					}	
			}
			else 
			{
				if(touch_delay5 == 3){ 			//delay        
					touch_delay5 = 0;
					new_touch5 = 1;
					}
				touch_delay5++;	
			}
			//calculate slider 6
			if (pre_c6 > 0){
				touch_delay6 = 0;
				if (new_touch6 == 1){
					rel_old_c6 = rel_c6;
					new_touch6 = 0;
					}
				if (rel_old_c6 > rel_c6){
					rel_temp = rel_old_c6 - rel_c6;
					if (rel_temp > 0){
						abs_c6 = abs_c6 - rel_temp;
						}
					}
				if (rel_old_c6 < rel_c6){
					rel_temp = rel_c6-rel_old_c6;
					if (rel_temp > 0){
						abs_c6 = abs_c6 + rel_temp;
						}
					}		
				if (abs_c6 > 159){
					abs_c6 =159;
					touch_delay6 = 0;
					new_touch6 = 1;
					}
				if (abs_c6 < 105){
					abs_c6 =105;
					touch_delay6 = 0;
					new_touch6 = 1;
					}
			}
			else 
			{
				if(touch_delay6 == 3){ 			//delay        
					touch_delay6 = 0;
					new_touch6 = 1;
					}
				touch_delay6++;	
			}
			//calculate slider 7
			if (pre_c7 > 0){
				touch_delay7 = 0;
				if (new_touch7 == 1){
					rel_old_c7 = rel_c7;
					new_touch7 = 0;
					}
				if (rel_old_c7 > rel_c7){
					rel_temp = rel_old_c7 - rel_c7;
					if (rel_temp > 0){
						abs_c7 = abs_c7 - rel_temp;
						}
					}
				if (rel_old_c7 < rel_c7){
					rel_temp = rel_c7-rel_old_c7;
					if (rel_temp > 0){
						abs_c7 = abs_c7 + rel_temp;
						}
					}		
				if (abs_c7 > 159){
					abs_c7 =159;
					touch_delay7 = 0;
					new_touch7 = 1;
					}
				if (abs_c7 < 105){
					abs_c7 =105;
					touch_delay7 = 0;
					new_touch7 = 1;
					}	
			}
			else 
			{
				if(touch_delay7 == 3){ 			//delay        
					touch_delay7 = 0;
					new_touch7 = 1;
					}
				touch_delay7++;	
			}
			//calculate slider 8
			if (pre_c8 > 0){
				touch_delay8 = 0;
				if (new_touch8 == 1){
					rel_old_c8 = rel_c8;
					new_touch8 = 0;
					}
				if (rel_old_c8 > rel_c8){
					rel_temp = rel_old_c8 - rel_c8;
					if (rel_temp > 0){
						abs_c8 = abs_c8 - rel_temp;
						}
					}
				if (rel_old_c8 < rel_c8){
					rel_temp = rel_c8-rel_old_c8;
					if (rel_temp > 0){
						abs_c8 = abs_c8 + rel_temp;
						}
					}		
				if (abs_c8 > 159){
					abs_c8 =159;
					touch_delay1 = 0;
					new_touch1 = 1;
					}
				if (abs_c8 < 105){
					abs_c8 =105;
					touch_delay8 = 0;
					new_touch8 = 1;
					}	
			}
			else 
			{
				if(touch_delay8 == 3){ 			//delay        
					touch_delay8 = 0;
					new_touch8 = 1;
					}
				touch_delay8++;	
			}
		}
		//find exit-touch oled 2
		//LOAD_EXIT();		
		//LOAD_CONFIG_5004_OLED_EXIT();
		//LOAD_CONFIG_5004_OLED_EXIT();
		LOAD_OLED_EXIT();
		LOAD_CONFIG_5004();
		RUN_OLED_EXIT();
		if ((exit_var ==1)&&(menue_var==0)){
			//exit_var = 0;
			enter_var = 0;
			return;
		}	
		menue_var=0; //reset menue var
	}
	
}

void oled_demo(void)
{
	//reset vars
	BYTE oled1_on_var = 0;
	BYTE oled2_on_var = 0;
	
	CLEAR_RAM();
	
	//display instructions 
	GRAPH_DRAW_STRING_RAM(40, 20, "OLED DEMO");
	GRAPH_DRAW_STRING_RAM(4, 4, "<-");
	GRAPH_DRAW_STRING_RAM(4, 14, "<-");
	GRAPH_DRAW_STRING_RAM(4, 24, "<-");
	GRAPH_DRAW_STRING_RAM(4, 34, "<-");
	GRAPH_DRAW_STRING_RAM(120, 3, "->");
	GRAPH_DRAW_STRING_RAM(120, 14, "->");
	GRAPH_DRAW_STRING_RAM(120, 24, "->");
	GRAPH_DRAW_STRING_RAM(120, 34, "->");
	GRAPH_DRAW_STRING_RAM(85, 56, "Return |");
	DISP_SEND_FRAME();
	
	while(1){

		for (run_matrix=0;run_matrix<120;run_matrix++){
	
			//LOAD_EXIT(); //init for oled sonsors
			//LOAD_CONFIG_5004_OLED();
			//LOAD_CONFIG_5004_OLED();
			LOAD_OLED();
			LOAD_CONFIG_5004();
			RUN_OLED(); //read oled sensor values
		
			oled1_on_var = 0;
			oled2_on_var = 0;
		
			//set pwm timings OLED 1, sensor value > 250
			if (SAR_RAW_OLED1>250){
				PT2_DATA0 = 0x00; // 0 cycles
				PT2_DATA1 = 0x01;// 768 cycles
				SAR_RAW_OLED1 = 251;
				oled1_on_var = 1;
				}
		
			//set pwm timings OLED 2, sensor value > 250
			if (SAR_RAW_OLED2>250){
				PT1_DATA0 = 0x00; // 0 cycles
				PT1_DATA1 = 0x01;// 768 cycles
				SAR_RAW_OLED2 = 251;
				oled2_on_var = 1;
				}
				
			//set pwm timings OLED 1, sensor value < 251
			if ((SAR_RAW_OLED1<251) && (SAR_RAW_OLED1>0)){
				PT2_DATA0 = SAR_RAW_OLED1; //
				PT2_DATA1 = 0x00;// 768 cycles
				oled1_on_var = 1;
				}
			
			//set pwm timings OLED 2, sensor value < 251
			if ((SAR_RAW_OLED2<251) && (SAR_RAW_OLED2>0)){
				PT1_DATA0 = SAR_RAW_OLED2; //
				PT1_DATA1 = 0x00;// 768 cycles
				oled2_on_var = 1;
				}
			
			//reduce delays for exit sensor read in
			if (run_matrix==120){
				PT0_DATA0 = 0x08;
				PT0_DATA1 = 0x01;
				}
			else 
				{
				PT0_DATA0 = 0x10;
				PT0_DATA1 = 0x01;
				}
			
			//set ports for OLEDs on
			//first cathode on than anode on
			//WARNING: don`t start RUN_OLED when OLEDs are on, this overloading PE5004 sensor pins
			if ((oled1_on_var == 1) && (oled2_on_var == 0)){
				PRT3DR = 0b00000111; //OLED1 cathode on
				PRT3DR = 0b00010111; //OLED1 anode on
				}
			if ((oled1_on_var == 0) && (oled2_on_var == 1)){
				PRT3DR = 0b00001011; //OLED2 cathode on
				PRT3DR = 0b00101011; //OLED2 anode on
				}
			if ((oled1_on_var == 1) && (oled2_on_var == 1)){
				PRT3DR = 0b00001111; //OLED2 and OLED1 cathode on
				PRT3DR = 0b00111111; //OLED2 and OLED1 anode on
				}
			
			PT0_CFG = 0x03; // start Timer0
			PT1_CFG = 0x03; // start Timer1
			PT2_CFG = 0x03; // start Timer2

			//set ports for OLEDs off
			while (PT0_CFG & 0x01){
				if (((PT1_CFG & 0x01) == 0) && (oled2_on_var == 1)){
					if (oled1_on_var == 1){
						PRT3DR = 0b00011111; //OLED1 anode off, OLED2 still on
						PRT3DR = 0b00010111; //OLED1 cathode off, OLED2 still on
						}
					else{
						PRT3DR = 0b00001011; //OLED1 anode off, OLED2 off
						PRT3DR = 0b00000011; //OLED1 cathode off, OLED2 off
						}
					oled2_on_var = 0;
					}
			
				if (((PT2_CFG & 0x01) == 0) && (oled1_on_var == 1)){
					if (oled2_on_var == 1){
						PRT3DR = 0b00101111; //OLED2 anode off, OLED1 still on
						PRT3DR = 0b00101011; //OLED2 cathode off,OLED1 still on
						}
					else{
						PRT3DR = 0b00000111; //OLED2 anode off, OLED1 off
						PRT3DR = 0b00000011; //OLED2 cathode off, OLED1 off
						}
					oled1_on_var = 0;
					}
				}
				
			PT0_CFG = 0x02;	// stop Timer0
			PT1_CFG = 0x02; // stop Timer1
			PT2_CFG = 0x02; // stop Timer2
			} //end for
		
		//find matrix exit touch
		LOAD_Matrix_EXIT();	
		LOAD_CONFIG_5004();	
		LOAD_CONFIG_5004();	
		RUN_MATRIX_EXIT();
		if ((matrix_exit_var ==1)&&(menue_var==0)){
			matrix_exit_var = 0;
			exit_var = 1;
			enter_var = 0;
			return;
			}	
		menue_var=0;
		
		} //end while
}
