/********************************************************************
    Project :   PE5004 Evaboard
    Version :   v2.0             
    Software:   PSoC Designer 
    Hardware:   PSoC MiniProg, PE5004 Evaboard
	Device	: 	CY7C64356
    Date    :   Jan 29 2009
    Author  :   HoJ
    Company :   PE Gmbh               

	desgription: sensor processing source code,
				 spi_functions needed 
	
******************************************************************************/


void CALIBRATE_MATRIX(void){
    
    BYTE loop_calib=0; //reset loop_calib
    SPI_SEND_5004(0x01, 0x00, 0x00, 0x00); // stop 5004
    PT0_DATA0 = 0xC0; // 129 cycles
    PT0_DATA1 = 0x03;// 768 cycles
    PT0_CFG = 0x03; // start Timer0 32khz one shot (30ms)
	
	for (count_var=0;count_var<58;count_var++)SAR_CALIB[count_var]=255; //reset SAR_CALIB
    while(PT0_CFG & 0x01); // wait 30ms for PE5004 to stop
	
	//50 times matrix run
    while(loop_calib<10){
    	//SPI_SEND_5004(0x01, REG1[2],REG1[1],REG1[0]); //start 5004 single
		SPI_SEND_5004(0x01, ( COLSTART_ROWSTART >>4 ), ( COLSTART_ROWSTART << 4 | COLEND_ROWEND >>4 ), ( COLEND_ROWEND << 4 | START_5004 ));
        COL_ROW = 0;
		pCALIB= &SAR_CALIB[0];
		PT0_DATA0 = 0xC0; // 129 cycles
    	PT0_DATA1 = 0x03;// 768 cycles
    	PT0_CFG = 0x03; // start Timer0 32khz one shot (30ms)
		
        while (1){
            if (INT_PORT & INT0){     //poll for interrupt (OLED_Enable must not be set!!)
				SPI_READ_5004_internal_sensors();      //read sensordata			
				if ((COL>0) && (ROW>1)){
               		if (*pCALIB>SAR_DATA){ //save current SAR_DATA value if lower than older
						(*pCALIB=SAR_DATA);
						}  
					pCALIB++; //increase pointer
					}
                if (COL_ROW == COLEND_ROWEND)break; // break if last sensor is read
				while (INT_PORT & 0x03){
					SPI_READ_5004_internal_sensors(); 
					}
            	}
			if (!(PT0_CFG & 0x01))break; // check for timeout
        	}
		PT0_CFG = 0x02; // stop Timer0
		PT0_DATA0 = 0x04; // 4 cycles
    	PT0_DATA1 = 0x00;// 0 cycles
    	PT0_CFG = 0x03; // start Timer0 32khz one shot (125us)
    	while (PT0_CFG & 0x01); // wait until Timer0 is zero
        	loop_calib++; //increase loop variable
    		}
    SPI_SEND_5004(0x01, 0x00, 0x00, 0x00); // stop 5004
}

void CALIBRATE_OLED(void){
    
    BYTE loop_calib=0;
    SPI_SEND_5004(0x01, 0x00, 0x00, 0x00); // stop 5004
    PT0_DATA0 = 0xC0; // 129 cycles
    PT0_DATA1 = 0x03;// 768 cycles
    PT0_CFG = 0x03; // start Timer0 32khz one shot (30ms)
	SAR_CALIB_OLED1=254;
	SAR_CALIB_OLED2=254;
    while(PT0_CFG & 0x01); // w8 30ms for 5004 to stop
	
    while(loop_calib<10){
    	//SPI_SEND_5004(0x01, REG1_OLED[2],REG1_OLED[1],REG1_OLED[0]); //start 5004 single
	    SPI_SEND_5004(0x01, ( COLSTART_ROWSTART >>4 ), ( COLSTART_ROWSTART << 4 | COLEND_ROWEND >>4 ), ( COLEND_ROWEND << 4 | START_5004 ));
        COL_ROW = 0; 	
		PT0_DATA0 = 0xC0; // 129 cycles
    	PT0_DATA1 = 0x03;// 768 cycles
    	PT0_CFG = 0x03; // start Timer0 32khz one shot (30ms)
		
        while (1){
            if (INT_PORT & INT0){     //poll for interrupt (OLED_Enable must not be set!!)
				SPI_READ_5004_internal_sensors();      //read sensordata			
				if ((COL==0) && (ROW==0)){  //find OLED 1
               		if ((SAR_CALIB_OLED1>SAR_DATA) && (SAR_DATA > 0)){
						SAR_CALIB_OLED1=SAR_DATA; //save calib values for OLED 1
						}
					}
				if ((COL==0) && (ROW==1)){  //find OLED 2
               		if ((SAR_CALIB_OLED2>SAR_DATA) && (SAR_DATA > 0)){
						SAR_CALIB_OLED2=SAR_DATA; //save calib values for OLED 2
						}			
					}
                if (COL_ROW == COLEND_ROWEND)break; // break if last sensor is read
				while (INT_PORT & 0x03){ //wait until interrupt low
					SPI_READ_5004_internal_sensors(); //dummy read to assure last interrupt is low
					}
            	}
			if (!(PT0_CFG & 0x01))break; // check for timeout
        	}
		PT0_CFG = 0x02; // stop Timer0
		PT0_DATA0 = 0x04; // 4 cycles
    	PT0_DATA1 = 0x00;// 0 cycles
    	PT0_CFG = 0x03; // start Timer0 32khz one shot (125us)
    	while (PT0_CFG & 0x01); // wait until Timer0 is zero
        	loop_calib++; //increase loop variable
    		}
    SPI_SEND_5004(0x01, 0x00, 0x00, 0x00); // stop 5004
}

void CALIBRATE_OLED_EXIT(void){
    
    BYTE loop_calib=0;
    SPI_SEND_5004(0x01, 0x00, 0x00, 0x00); // stop 5004
    PT0_DATA0 = 0xC0; // 129 cycles
    PT0_DATA1 = 0x03;// 768 cycles
    PT0_CFG = 0x03; // start Timer0 32khz one shot (30ms)
	SAR_CALIB_OLED1=254;
	SAR_CALIB_OLED2=254;
    while(PT0_CFG & 0x01); // w8 30ms for 5004 to stop
	
    while(loop_calib<10){
    	//SPI_SEND_5004(0x01, REG1_OLED_EXIT[2],REG1_OLED_EXIT[1],REG1_OLED_EXIT[0]); //start 5004 single
	    SPI_SEND_5004(0x01, ( COLSTART_ROWSTART >>4 ), ( COLSTART_ROWSTART << 4 | COLEND_ROWEND >>4 ), ( COLEND_ROWEND << 4 | START_5004 ));
        COL_ROW = 0; 	
		PT0_DATA0 = 0xC0; // 129 cycles
    	PT0_DATA1 = 0x03;// 768 cycles
    	PT0_CFG = 0x03; // start Timer0 32khz one shot (30ms)
		
        while (1){
            if (INT_PORT & INT0){     //poll for interrupt (OLED_Enable must not be set!!)
				SPI_READ_5004_internal_sensors();      //read sensordata			
				if ((COL==0) && (ROW==0)){  //find OLED 1
               		if ((SAR_CALIB_OLED1>SAR_DATA) && (SAR_DATA > 0)){
						SAR_CALIB_EXIT_OLED1=SAR_DATA; //save calib values for OLED 1
						}
					}
				if ((COL==0) && (ROW==1)){  //find OLED 2
               		if ((SAR_CALIB_OLED2>SAR_DATA) && (SAR_DATA > 0)){
						SAR_CALIB_EXIT_OLED2=SAR_DATA; //save calib values for OLED 2
						}			
					}
                if (COL_ROW == COLEND_ROWEND)break; // break if last sensor is read
				while (INT_PORT & 0x03){ //wait until interrupt low
					SPI_READ_5004_internal_sensors(); //dummy read to assure last interrupt is low
					}
            	}
			if (!(PT0_CFG & 0x01))break; // check for timeout
        	}
		PT0_CFG = 0x02; // stop Timer0
		PT0_DATA0 = 0x04; // 4 cycles
    	PT0_DATA1 = 0x00;// 0 cycles
    	PT0_CFG = 0x03; // start Timer0 32khz one shot (125us)
    	while (PT0_CFG & 0x01); // wait until Timer0 is zero
        	loop_calib++; //increase loop variable
    		}
    SPI_SEND_5004(0x01, 0x00, 0x00, 0x00); // stop 5004
}

void RUN_MATRIX(void){
	pFILT= &SAR_FILT[0];
	pCALIB= &SAR_CALIB[0]; 
    //SPI_SEND_5004(0x01, REG1[2],REG1[1],REG1[0]);
    SPI_SEND_5004(0x01, ( COLSTART_ROWSTART >>4 ), ( COLSTART_ROWSTART << 4 | COLEND_ROWEND >>4 ), ( COLEND_ROWEND << 4 | START_5004 ));
    COL_ROW = 0;
    PT0_DATA0 = 0xC0; // 129 cycles
    PT0_DATA1 = 0x03;// 768 cycles
    PT0_CFG = 0x03; // start Timer0 32khz one shot (30ms)
    while (1){
        if (INT_PORT & INT0){
            SPI_READ_5004_internal_sensors();
			if ((COL>0) && (ROW>1)){  //start after OLED connects
	            if (*pCALIB-thresh > SAR_DATA){  //if measured data lesser then calibration data (touch lowers adc-value)
              		*pFILT=(((*pFILT<<1)+*pFILT+(*pCALIB-(SAR_DATA+thresh)))>>2); // (FILT*3+sar)/4 filtering
              		}
              	else *pFILT=(((*pFILT<<1)+*pFILT)>>3); //minimize current *pfilt value 
				pCALIB++;
				pFILT++;
				}
            if (COL_ROW == COLEND_ROWEND) break; // break if last sensor is read
			while (INT_PORT & 0x03){ //wait until interrupt low
				SPI_READ_5004_internal_sensors(); //dummy read to assure last interrupt is low
				}
        	}
        if (!(PT0_CFG & 0x01)) break; // check for timeout
    	}
    PT0_CFG = 0x02; // stop Timer0
	
    SPI_SEND_5004(0x01, 0x00, 0x00, 0x00); // stop 5004 
	PT0_DATA0 = 0x04; // 4 cycles
    PT0_DATA1 = 0x00;// 0 cycles
    PT0_CFG = 0x03; // start Timer0 32khz one shot (125us)
    while (PT0_CFG & 0x01); // wait until Timer0 is zero
}    

void RUN_MATRIX_cursor(void){
	pFILT= &SAR_FILT[0];
	pCALIB= &SAR_CALIB[0]; 
    //SPI_SEND_5004(0x01, REG1[2],REG1[1],REG1[0]);
    SPI_SEND_5004(0x01, ( COLSTART_ROWSTART >>4 ), ( COLSTART_ROWSTART << 4 | COLEND_ROWEND >>4 ), ( COLEND_ROWEND << 4 | START_5004 ));
    COL_ROW = 0;
    PT0_DATA0 = 0xC0; // 129 cycles
    PT0_DATA1 = 0x03;// 768 cycles
    PT0_CFG = 0x03; // start Timer0 32khz one shot (30ms)
    while (1){
        if (INT_PORT & INT0){
            SPI_READ_5004_internal_sensors();
			if ((COL>0) && (ROW>1)){  //???????????????????????????
	            if (*pCALIB-5 > SAR_DATA){  //if measured data lesser then calibration data (touch lowers adc-value)
              		*pFILT=SAR_DATA; //
              		}
              	else *pFILT=0; //minimize current *pfilt value 
				pCALIB++;
				pFILT++;
				}
            if (COL_ROW == COLEND_ROWEND) break; // break if last sensor is read
			while (INT_PORT & 0x03){ //wait until interrupt low
				SPI_READ_5004_internal_sensors(); //dummy read to assure last interrupt is low
				}
        	}
        if (!(PT0_CFG & 0x01)) break; // check for timeout
    	}
    PT0_CFG = 0x02; // stop Timer0
	
    SPI_SEND_5004(0x01, 0x00, 0x00, 0x00); // stop 5004 
	PT0_DATA0 = 0x04; // 4 cycles
    PT0_DATA1 = 0x00;// 0 cycles
    PT0_CFG = 0x03; // start Timer0 32khz one shot (125us)
    while (PT0_CFG & 0x01); // wait until Timer0 is zero
}    
 
 void RUN_MATRIX_EXIT(void){
 
    //SPI_SEND_5004(0x01, REG1[2],REG1[1],REG1[0]);
	SPI_SEND_5004(0x01, ( COLSTART_ROWSTART >>4 ), ( COLSTART_ROWSTART << 4 | COLEND_ROWEND >>4 ), ( COLEND_ROWEND << 4 | START_5004 ));
    COL_ROW = 0;
    PT0_DATA0 = 0xC0; // 129 cycles
    PT0_DATA1 = 0x03;// 768 cycles
    PT0_CFG = 0x03; // start Timer0 32khz one shot (30ms)
    while (1){
        if (INT_PORT & INT0){
            SPI_READ_5004_internal_sensors();
			if ((COL==1) && (ROW==4)){
	            if (SAR_CALIB[2]-Matrix_exit_tresh > SAR_DATA){  //if measured data lesser then calibration data (touch lowers adc-value)
					matrix_exit_var=1;
              		}
				}
            if (COL_ROW == 0x14) break; // break if last sensor is read
			while (INT_PORT & 0x03){ //wait until interrupt low
				SPI_READ_5004_internal_sensors(); //dummy read to assure last interrupt is low
				}
        	}
        if (!(PT0_CFG & 0x01)) break; // check for timeout
    	}
    PT0_CFG = 0x02; // stop Timer0
    SPI_SEND_5004(0x01, 0x00, 0x00, 0x00); // stop 5004 
	PT0_DATA0 = 0x04; // 129 cycles
    PT0_DATA1 = 0x00;// 768 cycles
    PT0_CFG = 0x03; // start Timer0 32khz one shot (125us)
    while (PT0_CFG & 0x01); // wait until Timer0 is zero
}    
 
//matrix and OLED sensors read for GUI (PC)	
void RUN_MATRIX_OLED_USB(void){
	pRAW= &SAR_RAW[0]; 
    //SPI_SEND_5004(0x01, REG1[2],REG1[1],REG1[0]);
	SPI_SEND_5004(0x01, ( COLSTART_ROWSTART >>4 ), ( COLSTART_ROWSTART << 4 | COLEND_ROWEND >>4 ), ( COLEND_ROWEND << 4 | START_5004 ));
    COL_ROW = 0;
    PT0_DATA0 = 0xC0; // 129 cycles   0xC0
    PT0_DATA1 = 0x05;// 768 cycles
    PT0_CFG = 0x03; // start Timer0 32khz one shot (30ms)
    while (1){
        if (INT_PORT & INT0){
            SPI_READ_5004_internal_sensors();		
			//if ((COL>0) && (ROW>1)){
				*pRAW=SAR_DATA; //save current sensor value
				pRAW++;
			//}
            if (COL_ROW == COLEND_ROWEND) break; // break if last sensor is read
			//while (INT_PORT & INT0);
			while (INT_PORT & 0x03){ //wait until interrupt low
				SPI_READ_5004_internal_sensors(); //dummy read to assure last interrupt is low
				}
        }
        if (!(PT0_CFG & 0x01)) break; // check for timeout
    }
    PT0_CFG = 0x02; // stop Timer0
}    

//external sensors read for GUI (PC)
void RUN_MATRIX_USB_external_sensors(void){
	pRAW= &SAR_RAW[0]; 
	pRAW2= &SAR_RAW2[0]; 
    //SPI_SEND_5004(0x01, REG1[2],REG1[1],REG1[0]);
	SPI_SEND_5004(0x01, ( COLSTART_ROWSTART >>4 ), ( COLSTART_ROWSTART << 4 | COLEND_ROWEND >>4 ), ( COLEND_ROWEND << 4 | START_5004 ));
    COL_ROW = 0;
    PT0_DATA0 = 0xC0; // 129 cycles   0xC0
    PT0_DATA1 = 0x05;// 768 cycles
    PT0_CFG = 0x03; // start Timer0 32khz one shot (30ms)
    while (1){
        if (INT_PORT & INT1){
            SPI_READ_5004_external_sensors();	
			     //SAR_DATA	15	14	13	12	11	10	9	8	7	6	5	4	3	2	  1	    0
			     //      	'0'	'0'	------------SAR_DATA 10bit------------ '0'	ECOL  EROW  SARMode
				*pRAW=SAR_DATA; 	//   SAR_DATA bits 15..8
				*pRAW2=SAR_DATA2;   //   SAR_DATA bits 7..0
				pRAW++;
				pRAW2++;
            if (COL_ROW == COLEND_ROWEND) break; // break if last sensor is read 
			while (INT_PORT & 0x03){ //wait until interrupt low
				SPI_READ_5004_internal_sensors(); //dummy read to assure last interrupt is low
				}
        	}
        if (!(PT0_CFG & 0x01)) break; // check for timeout
    	}
    PT0_CFG = 0x02; // stop Timer0
}   

//WARNING: don`t start RUN_OLED_EXIT when OLEDs are on, this overloading PE5004 sensor pins
void RUN_OLED_EXIT(void){

    //SPI_SEND_5004(0x01, REG1_OLED_EXIT[2],REG1_OLED_EXIT[1],REG1_OLED_EXIT[0]);
	SPI_SEND_5004(0x01, ( COLSTART_ROWSTART >>4 ), ( COLSTART_ROWSTART << 4 | COLEND_ROWEND >>4 ), ( COLEND_ROWEND << 4 | START_5004 ));
    COL_ROW = 0;
    PT0_DATA0 = 0xC0; // 129 cycles
    PT0_DATA1 = 0x03;// 768 cycles
    PT0_CFG = 0x03; // start Timer0 32khz one shot (30ms)
	
    while (1){
        if (INT_PORT & INT0){
            SPI_READ_5004_internal_sensors();
			if ((COL==0) && (ROW==0)){
				if ((SAR_DATA |= 0)){ 
	            	if ((SAR_CALIB_EXIT_OLED1-Oled_exit_tresh > SAR_DATA)&(enter_var==1)){  //if measured data lesser then calibration data (touch lowers adc-value)
						exit_var=1; //set exit oled touched
						//SAR_RAW_OLED1=SAR_DATA;
              			}
					}
				}
			if ((COL==0) && (ROW==1)){
				if ((SAR_DATA |= 0)){
	            	if (SAR_CALIB_EXIT_OLED2-Oled_exit_tresh > SAR_DATA){  //if measured data lesser then calibration data (touch lowers adc-value)
						enter_var=1; //set enter oled touched
						//SAR_RAW_OLED2=SAR_DATA;
						//SPI_READ_5004_internal_sensors(); //dummy read to assure last interrupt is low ????????????????????????????????
              			}
					}
				}
            if (COL_ROW == COLEND_ROWEND) break; // break if last sensor is read 
			//if (COL_ROW == 0x01) break; // break if last sensor is read  
			while (INT_PORT & 0x03){ //wait until interrupt low
				SPI_READ_5004_internal_sensors(); //dummy read to assure last interrupt is low
				}
        	}
        if (!(PT0_CFG & 0x01)) break; // check for timeout
    	}
    PT0_CFG = 0x02; // stop Timer0
    SPI_SEND_5004(0x01, 0x00, 0x00, 0x00); // stop 5004 
	PT0_DATA0 = 0x04; // 4 cycles
    PT0_DATA1 = 0x00;// 0 cycles
    PT0_CFG = 0x03; // start Timer0 32khz one shot (125us)
    while (PT0_CFG & 0x01); // w8
} 

//WARNING: don`t start RUN_OLED when OLEDs are on, this overloading PE5004 sensor pins
void RUN_OLED(void){

    //SPI_SEND_5004(0x01, REG1_OLED[2],REG1_OLED[1],REG1_OLED[0]);
	SPI_SEND_5004(0x01, ( COLSTART_ROWSTART >>4 ), ( COLSTART_ROWSTART << 4 | COLEND_ROWEND >>4 ), ( COLEND_ROWEND << 4 | START_5004 ));
    COL_ROW = 0;
	
    while (1){
        if (INT_PORT & INT0){
            SPI_READ_5004_internal_sensors();
			if ((COL==0) && (ROW==0)){
				if ((SAR_DATA |= 0)){ // && (SAR_DATA |= 255))
	            	if ((SAR_CALIB_OLED1-thresh_oled) > SAR_DATA){  //if measured data lesser then calibration data (touch lowers adc-value)
						SAR_RAW_OLED1=(((SAR_RAW_OLED1>>1)+(SAR_RAW_OLED1>>2)+(SAR_RAW_OLED1>>3)+(SAR_CALIB_OLED1-(SAR_DATA+thresh_oled))));
              			}
					else SAR_RAW_OLED1=(((SAR_RAW_OLED1<<2)+SAR_RAW_OLED1)>>3);
					}
				}
			if ((COL==0) && (ROW==1)){
				if ((SAR_DATA |= 0)) {//&& (SAR_DATA |= 255))
	            	if ((SAR_CALIB_OLED2-thresh_oled) > SAR_DATA){  //if measured data lesser then calibration data (touch lowers adc-value)
						SAR_RAW_OLED2=(((SAR_RAW_OLED2>>1)+(SAR_RAW_OLED2>>2)+(SAR_RAW_OLED2>>3)+(SAR_CALIB_OLED2-(SAR_DATA+thresh_oled))));
              			}
					else SAR_RAW_OLED2=(((SAR_RAW_OLED2<<2)+SAR_RAW_OLED2)>>3);
					}
				}
            if (COL_ROW == 0x01) break; // break if last sensor is read  0x01
			while (INT_PORT & 0x03){ //wait until interrupt low
				SPI_READ_5004_internal_sensors(); //dummy read to assure last interrupt is low
				}
        	}
    	}
	PT0_CFG = 0x02; // stop Timer0
    SPI_SEND_5004(0x01, 0x00, 0x00, 0x00); // stop 5004 
	PT0_DATA0 = 0x04; // 4 cycles
    PT0_DATA1 = 0x00;// 0 cycles
    PT0_CFG = 0x03; // start Timer0 32khz one shot (125us)
    while (PT0_CFG & 0x01); // w8
	PT0_CFG = 0x02; // stop Timer0
} 

