/********************************************************************
    Project :   PE5004 Evaboard
    Version :   v2.0             
    Software:   PSoC Designer 
    Hardware:   PSoC MiniProg, PE5004 Evaboard
	Device	: 	CY7C64356
    Date    :   Jan 29 2009
    Author  :   HoJ
    Company :   PE Gmbh               

	desgription: sensor processing header-file
	
******************************************************************************/

#include <m8c.h> // part specific constants and macros



//oled sensor variables
WORD SAR_CALIB_OLED1;
WORD SAR_CALIB_OLED2;
WORD SAR_CALIB_EXIT_OLED1;
WORD SAR_CALIB_EXIT_OLED2;
WORD SAR_FILT_OLED[2];
WORD SAR_RAW_OLED1;
WORD SAR_RAW_OLED2;

//matrix and external sensor variables and pointers
BYTE SAR_CALIB[58]; //only for on board sensors
BYTE SAR_RAW[100];  //for both sensors
BYTE SAR_RAW2[100]; //only for external sensors
WORD SAR_FILT[58]; //only for on board sensors
BYTE SAR_CALC;
WORD *pFILT;
BYTE *pCALIB;
BYTE *pRAW;
BYTE *pRAW2;


//-------------------------------------------------
// Prototypes
//-------------------------------------------------

void CALIBRATE_MATRIX(void); //calibrating onboard matrix sensors

void CALIBRATE_OLED(void); //calibrating onboard oled sensors

void CALIBRATE_OLED_EXIT(void); //calibrating onboard oled sensors for exit function
    
void RUN_MATRIX(void);
 
void RUN_MATRIX_EXIT(void);
    
void RUN_MATRIX_OLED_USB(void);  

void RUN_MATRIX_USB_external_sensors(void);

void RUN_OLED_EXIT(void);

void RUN_OLED(void); 

//-------------------------------------------------
// source code
//-------------------------------------------------
#include "sensor_processing.c"
